View Issue Details

IDProjectCategoryView StatusLast Update
0031248LazarusLCLpublic2020-08-04 04:23
ReporterSergey Tsukanov Assigned ToOndrej Pokorny  
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
OSWindows 
Product Version1.6.2 
Target Version1.8 
Summary0031248: TForm.ShowInTaskBar = stAlways works only when form show on first time, and not work on next times.
Description1. Click Button1
2. Close Form2
3. Click Button1
Application button not visible in taskbar while Form2 visible.
TagsNo tags attached.
Fixed in Revision54722
LazTarget1.8
WidgetsetWin32/Win64
Attached Files

Relationships

related to 0017294 resolvedOndrej Pokorny ShowInTaskBar = stNever does nothing 
related to 0022768 resolvedOndrej Pokorny There is no way to hide application from taskbar 
related to 0022587 resolvedOndrej Pokorny Two thumnails on taskbar when ShowInTaskBar is stAlways 
related to 0018480 resolvedOndrej Pokorny Main form icon dissappears from Alt-Tab task list when form with ShowInTaskBar=stAlways active 

Activities

Sergey Tsukanov

2017-01-18 14:32

reporter  

ShowInTaskBar_bug.zip (130,809 bytes)

Michl

2017-03-05 18:32

developer   ~0098664

Last edited: 2017-03-05 18:34

View 2 revisions

This issue comes with revision 24750: LCL: optimized TCustomForm.UpdateShowInTaskBar

I assign this issue to Mattias.

Possible patch added (removed optimizion from 24750), but I'm not sure about side effects on other widgetsets.

Michl

2017-03-05 18:33

developer  

forms.patch (1,068 bytes)   
Index: lcl/forms.pp
===================================================================
--- lcl/forms.pp	(revision 54344)
+++ lcl/forms.pp	(working copy)
@@ -471,7 +471,6 @@
     FOnShow: TNotifyEvent;
     FOnWindowStateChange: TNotifyEvent;
     FPosition: TPosition;
-    FRealizedShowInTaskBar: TShowInTaskbar;
     FRestoredLeft: integer;
     FRestoredTop: integer;
     FRestoredWidth: integer;
Index: lcl/include/customform.inc
===================================================================
--- lcl/include/customform.inc	(revision 54344)
+++ lcl/include/customform.inc	(working copy)
@@ -899,11 +899,7 @@
      (not HandleAllocated) or Assigned(Parent) or
      (FormStyle = fsMDIChild) or not Showing then Exit;
   Value := GetEffectiveShowInTaskBar;
-  if FRealizedShowInTaskBar <> Value then
-  begin
-    FRealizedShowInTaskBar := Value;
-    TWSCustomFormClass(WidgetSetClass).SetShowInTaskbar(Self, Value);
-  end;
+  TWSCustomFormClass(WidgetSetClass).SetShowInTaskbar(Self, Value);
 end;
 
 class procedure TCustomForm.WSRegisterClass;
forms.patch (1,068 bytes)   

Juha Manninen

2017-04-24 21:46

developer   ~0099883

This is a regression. Target = 1.8.

Ondrej Pokorny

2017-04-25 10:15

developer   ~0099903

I applied your patch, Michl. The comment in TCustomForm.WMActivate describes why the update is needed regardless of old value.

Issue History

Date Modified Username Field Change
2017-01-18 14:32 Sergey Tsukanov New Issue
2017-01-18 14:32 Sergey Tsukanov File Added: ShowInTaskBar_bug.zip
2017-03-05 18:32 Michl Note Added: 0098664
2017-03-05 18:32 Michl Assigned To => Mattias Gaertner
2017-03-05 18:32 Michl Status new => assigned
2017-03-05 18:33 Michl File Added: forms.patch
2017-03-05 18:34 Michl Note Edited: 0098664 View Revisions
2017-04-24 21:33 Juha Manninen Relationship added related to 0017294
2017-04-24 21:34 Juha Manninen Relationship added related to 0022768
2017-04-24 21:42 Juha Manninen Relationship added related to 0022587
2017-04-24 21:44 Juha Manninen Relationship added related to 0018480
2017-04-24 21:46 Juha Manninen LazTarget => -
2017-04-24 21:46 Juha Manninen Note Added: 0099883
2017-04-24 21:46 Juha Manninen Target Version => 1.8
2017-04-24 21:47 Juha Manninen LazTarget - => 1.8
2017-04-25 10:00 Ondrej Pokorny Assigned To Mattias Gaertner => Ondrej Pokorny
2017-04-25 10:15 Ondrej Pokorny Fixed in Revision => 54722
2017-04-25 10:15 Ondrej Pokorny Note Added: 0099903
2017-04-25 10:15 Ondrej Pokorny Status assigned => resolved
2017-04-25 10:15 Ondrej Pokorny Resolution open => fixed
2020-08-04 04:23 Sergey Tsukanov Status resolved => closed